##Utworzone w 17.06.2017
#Celem projektu było napisanie programu który symuluje ruch planet w układzie słonecznym, oraz przedstawia na wykresach niektóre z zależności.
#
#@author: Grzegorz Wolanin
#@author: Wojceich Noga
#@author: Krzysztof Jaje
##

from visual import*
from visual.graph import*
from visual.materials import texture

##Tutaj pokazujemy nasz System Sloneczny
scene = display (x = 650, title = "Uklad Sloneczny", width = 1280, height = 1024, range = (5000,5000,25000), center = (0,0,0))
scene.autoscale = True

##tworzenie obiektow w skali 17,24 dla odleglosci i 0,00084 dla promieni
sun = sphere(pos=(0,0,0), radius=586, material = materials.emissive, color=color.yellow)

mercury = sphere(pos=(1000.,0,0), radius=2.1, material = materials.wood, color=color.red)
mercury.trail = curve(color=mercury.color)
mercury.velocity = vector (0,0,117)

venus = sphere(pos = (1862.414,0,0),radius=5.1, material = materials.wood, color=color.orange)
venus.trail = curve(color=venus.color)
venus.velocity = vector (0,0,85.53)

earth = sphere(pos = (2586.241,0,0), radius = 5.4, material = materials.earth)#, color = color.yellow)
earth.trail = curve(color=color.blue)
earth.velocity = vector (0,0,72.75)

moon = sphere(pos = (2586.241+6.552,0,0), radius=1.5, material = materials.rough, color=color.white)
moon.trail = curve(color=moon.color)
moon.velocitylocal = vector(0,0,2.44)
moon.velocityglobal = earth.velocity + moon.velocitylocal

mars = sphere(pos=(3931.206,0,0), radius=2.9, material = materials.wood, color=color.green)
mars.trail = curve(color=mars.color)
mars.velocity = vector (0,0,59)

jupiter = sphere(pos=(13413.759,0,0), radius=180.4, material = materials.marble, color=color.cyan)
jupiter.trail = curve(color=jupiter.color)
jupiter.velocity = vector(0,0,31.95)

saturn = sphere(pos=(24137.586,0,0), radius=50.7, material = materials.marble, color=color.yellow)
saturn.trail = curve(color=saturn.color)
saturn.velocity = vector (0,0,23.6)

uranus = sphere(pos=(50000.,0,0), radius=21.5, material = materials.wood, color=color.magenta)
uranus.trail = curve(color=uranus.color)
uranus.velocity = vector(0,0,16.71)

neptune = sphere(pos=(77586.241,0,0), radius = 20.9, material = materials.wood, color=color.red)
neptune.trail = curve(color=neptune.color)
neptune.velocity = vector(0,0,13.27)

pluto = sphere(pos=(101724.828,0,0),radius=1, material = materials.marble, color=color.orange)
pluto.trail = curve(color=pluto.color)
pluto.velocity = vector (0,0,11.55)

##Stala G powiekszona o 7 rzedow "-" bo przeciwny zwrot
G = -6.7*10**-4
#masy wszystkich obiektow skala 1
m_sun = 2*10**10
m_mercury = 3.29*10**3
m_venus = 4.87*10**4
m_earth = 6.0*10**4
m_moon = 7.35*10**2
m_mars = 6.39*10**3
m_jupiter = 1.90*10**7
m_saturn = 5.68*10**6
m_uranus = 8.68*10**5
m_neptune = 1.02*10**6
m_pluto = 1.31*10**2

#Stosunek predkosci innych planet do Ziemi
mercury_Realratio = 1.600
venus_Realratio = 1.177
earth_Realratio = 1.
mars_Realratio = 0.805
jupiter_Realratio = 0.437
saturn_Realratio = 0.324
uranus_Realratio = 0.228
neptune_Realratio = 0.182
pluto_Realratio = 0.158

t = 0
dt = 0.01
#time_interval = 0.05
#time_interval_int = int(time_interval/dt)


graphpos = gdisplay (x=0, y=600, xtitle="Czas", ytitle="Pozycja", width=600, height=400,title= "Zmiana pozycji Ziemi i Ksiezyca w czasie" )
earthposx = gcurve(gdisplay=graphpos, color = color.green)
moonposx = gcurve(gdisplay=graphpos, color = color.white)
graphpos = gdisplay (x=0, y=0, xtitle="Czas", ytitle="Odleglosc", width=600, height=400,title= "Zmiana odleglosci Ksiezyca od Ziemi w czasie" )
distanceMoon_earthpos = gcurve(gdisplay=graphpos, color = color.green)


graphv = gdisplay (x=600, y=0, xtitle="Czas", ytitle="Predkosc", width=600, height=400, foreground = color.black, background = color.white, title = "Zmiana predkosci Ziemi w czasie")
earthvelocity = gcurve(gdisplay=graphv, color=color.blue)

tlist = []
vlist = []

graphGPE = gdisplay (x=600, y=400, xtitle="Pozycja", ytitle="Energia potencjalna grawitacji", width=800, height=400, title = "EPG i pozycja Ziemi wzgledem Slonca")
earthGPE = gcurve(gdisplay=graphGPE, color=color.green)


graphSpeedRatios = gdisplay (x=0, y=400, xtitle="Czas", ytitle="Stosunek predkosci", width=600, height=400, title = "Predkosci planet w stosunku do Ziemi")
mercuryRatio = gcurve (gdisplay=graphSpeedRatios, color=color.red)
mercuryRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.red)

venusRatio = gcurve (gdisplay=graphSpeedRatios, color=color.orange)
venusRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.orange)

earthRatio = gcurve (gdisplay=graphSpeedRatios, color=color.yellow)
earthRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.yellow)

marsRatio = gcurve (gdisplay=graphSpeedRatios, color=color.green)
marsRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.green)

jupiterRatio = gcurve (gdisplay=graphSpeedRatios, color=color.cyan)
jupiterRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.cyan)

saturnRatio = gcurve (gdisplay=graphSpeedRatios, color=color.blue)
saturnRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.blue)

uranusRatio = gcurve (gdisplay=graphSpeedRatios, color=color.magenta)
uranusRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.magenta)

neptuneRatio = gcurve (gdisplay=graphSpeedRatios, color=color.red)
neptuneRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.red)

plutoRatio = gcurve (gdisplay=graphSpeedRatios, color=color.orange)
plutoRealRatio = gdots (gdisplay=graphSpeedRatios, size=2, color=color.orange)

##Glowna petla
while True:
    rate (10000) # 10000

    mercury.trail.append(pos=mercury.pos)
    distanceMercury = mag(mercury.pos)
    UnitVectorMercury = (mercury.pos - sun.pos)/distanceMercury
    FgravMercury = (G*m_sun*m_mercury*UnitVectorMercury)/distanceMercury**2
    mercury.velocity = mercury.velocity + (FgravMercury/m_mercury)*dt
    mercury.pos = mercury.pos + mercury.velocity*dt
    mercury.rotate(angle=radians(0.094), axis=(0,1,0))
    if distanceMercury <= sun.radius: break
    mercury_Ratio = mag(mercury.velocity) / mag(earth.velocity)

    venus.trail.append(pos=venus.pos)
    distanceVenus = mag(venus.pos)
    UnitVectorVenus = (venus.pos - sun.pos)/distanceVenus
    FgravVenus = (G*m_sun*m_venus*UnitVectorVenus)/distanceVenus**2
    venus.velocity = venus.velocity + (FgravVenus/m_venus)*dt
    venus.pos = venus.pos + venus.velocity*dt
    venus.rotate(angle=radians(0.023), axis=(0,1,0))
    if distanceVenus <= sun.radius: break
    venus_Ratio = mag(venus.velocity) / mag(earth.velocity)

    earth.trail.append(pos=earth.pos)
    distanceEarth = mag(earth.pos)
    UnitVectorEarth = (earth.pos - sun.pos)/distanceEarth
    FgravEarth = (G*m_sun*m_earth*UnitVectorEarth)/distanceEarth**2
    earth.velocity = earth.velocity + (FgravEarth/m_earth)*dt
    earth.pos = earth.pos + earth.velocity*dt
    earth.rotate(angle=radians(5.52), axis=(0,1,0))
    earth_GPE = (G*m_sun*m_earth)/distanceEarth
    if distanceEarth <= sun.radius: break
    earth_Ratio = mag(earth.velocity) / mag(earth.velocity)

    moon.trail.append(pos=moon.pos)
    distanceMoon_earth = mag(moon.pos - earth.pos)
    distanceMoon_sun = mag(moon.pos - sun.pos)
    UnitVectorMoon_earth = (moon.pos - earth.pos)/distanceMoon_earth
    UnitVectorMoon_sun = (moon.pos - sun.pos)/distanceMoon_sun
    FgravMoon_earth = (G*m_earth*m_moon*UnitVectorMoon_earth)/distanceMoon_earth**2
    FgravMoon_sun =  (G*m_sun*m_moon*UnitVectorMoon_sun)/distanceMoon_sun**2
    moon.velocitylocal = moon.velocitylocal + (FgravMoon_earth/m_moon)*dt
    moon.velocityglobal = moon.velocityglobal + (FgravMoon_sun/m_moon)*dt #earth.velocity
    moon.pos = moon.pos + (moon.velocitylocal + earth.velocity)*dt
    moon.rotate(angle=radians(5.52), axis=(0,1,0))

    mars.trail.append(pos=mars.pos)
    distanceMars = mag(mars.pos)
    UnitVectorMars = (mars.pos - sun.pos)/distanceMars
    FgravMars = (G*m_sun*m_mars*UnitVectorMars)/distanceMars**2
    mars.velocity = mars.velocity + (FgravMars/m_mars)*dt
    mars.pos = mars.pos + mars.velocity*dt
    mars.rotate(angle=radians(5.38), axis=(0,1,0))
    if distanceMars <= sun.radius: break
    mars_Ratio = mag(mars.velocity) / mag(mars.velocity)

    jupiter.trail.append(pos=jupiter.pos)
    distanceJupiter = mag(jupiter.pos)
    UnitVectorJupiter = (jupiter.pos - sun.pos)/distanceJupiter
    FgravJupiter = (G*m_sun*m_jupiter*UnitVectorJupiter)/distanceJupiter**2
    jupiter.velocity = jupiter.velocity + (FgravJupiter/m_jupiter)*dt
    jupiter.pos = jupiter.pos + jupiter.velocity*dt
    jupiter.rotate(angle=radians(13.46), axis=(0,1,0))
    if distanceJupiter <= sun.radius: break
    jupiter_Ratio = mag(jupiter.velocity) / mag(jupiter.velocity)

    saturn.trail.append(pos=saturn.pos)
    distanceSaturn = mag(saturn.pos)
    UnitVectorSaturn = (saturn.pos - sun.pos)/distanceSaturn
    FgravSaturn = (G*m_sun*m_saturn*UnitVectorSaturn)/distanceSaturn**2
    saturn.velocity = saturn.velocity + (FgravSaturn/m_saturn)*dt
    saturn.pos = saturn.pos + saturn.velocity*dt
    saturn.rotate(angle=radians(12.38), axis=(0,1,0))
    if distanceSaturn <= sun.radius: break
    saturn_Ratio = mag(saturn.velocity) / mag(saturn.velocity)

    uranus.trail.append(pos=uranus.pos)
    distanceUranus = mag(uranus.pos)
    UnitVectorUranus = (uranus.pos - sun.pos)/distanceUranus
    FgravUranus = (G*m_sun*m_uranus*UnitVectorUranus)/distanceUranus**2
    uranus.velocity = uranus.velocity + (FgravUranus/m_uranus)*dt
    uranus.pos = uranus.pos + uranus.velocity*dt
    uranus.rotate(angle=radians(7.36), axis=(0,1,0))
    if distanceUranus <= sun.radius: break
    uranus_Ratio = mag(uranus.velocity) / mag(uranus.velocity)

    neptune.trail.append(pos=neptune.pos)
    distanceNeptune = mag(neptune.pos)
    UnitVectorNeptune = (neptune.pos - sun.pos)/distanceNeptune
    FgravNeptune = (G*m_sun*m_neptune*UnitVectorNeptune)/distanceNeptune**2
    neptune.velocity = neptune.velocity + (FgravNeptune/m_neptune)*dt
    neptune.pos = neptune.pos + neptune.velocity*dt
    neptune.rotate(angle=radians(8.24), axis=(0,1,0))
    if distanceNeptune <= sun.radius: break
    neptune_Ratio = mag(neptune.velocity) / mag(neptune.velocity)

    pluto.trail.append(pos=pluto.pos)
    distancePluto = mag(pluto.pos)
    UnitVectorPluto = (pluto.pos - sun.pos)/distancePluto
    FgravPluto = (G*m_sun*m_pluto*UnitVectorPluto)/distancePluto**2
    pluto.velocity = pluto.velocity + (FgravPluto/m_pluto)*dt
    pluto.pos = pluto.pos + pluto.velocity*dt
    pluto.rotate(angle=radians(0.86), axis=(0,1,0))
    if distancePluto <= sun.radius: break
    pluto_Ratio = mag(pluto.velocity) / mag(pluto.velocity)

    earthposx.plot(pos=(t,earth.pos.x))
    earthvelocity.plot(pos=(t,(earth.velocity.x**2 + earth.velocity.z**2)**1/2))
    earthGPE.plot(pos=(earth.pos.x,earth_GPE))
    moonposx.plot(pos=(t,moon.pos.x))
    distanceMoon_earthpos.plot(pos=(t,distanceMoon_earth))

    vlist.append(earth.velocity.x)
    tlist.append(t)
    t = t + dt

    mercuryRatio.plot(pos=(t,mercury_Ratio))
    mercuryRealRatio.plot(pos=(t,mercury_Realratio))

    venusRatio.plot(pos=(t,venus_Ratio))
    venusRealRatio.plot(pos=(t,venus_Realratio))

    earthRatio.plot(pos=(t,earth_Ratio))
    earthRealRatio.plot(pos=(t,earth_Realratio))

    marsRatio.plot(pos=(t,mars_Ratio))
    marsRealRatio.plot(pos=(t,mars_Realratio))

    jupiterRatio.plot(pos=(t,jupiter_Ratio))
    jupiterRealRatio.plot(pos=(t,jupiter_Realratio))

    saturnRatio.plot(pos=(t,saturn_Ratio))
    saturnRealRatio.plot(pos=(t,saturn_Realratio))

    uranusRatio.plot(pos=(t,uranus_Ratio))
    uranusRealRatio.plot(pos=(t,uranus_Realratio))

    neptuneRatio.plot(pos=(t,neptune_Ratio))
    neptuneRealRatio.plot(pos=(t,neptune_Realratio))

    plutoRatio.plot(pos=(t,pluto_Ratio))
    plutoRealRatio.plot(pos=(t,pluto_Realratio))





